diff -Naur src.pgsql/backend/access/bitmap/bitmappages.c src.bizgres/backend/access/bitmap/bitmappages.c
--- src.pgsql/backend/access/bitmap/bitmappages.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmappages.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,266 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmappage.c
+ *	  Bitmap index page management code for the bitmap index.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/tupdesc.h"
+#include "access/bitmap.h"
+#include "storage/lmgr.h"
+#include "parser/parse_oper.h"
+#include "miscadmin.h"
+
+/*
+ * _bitmap_getbuf() -- return the buffer for the given block number and
+ * 					   the access method.
+ * Note: This function does not support "P_NEW" block number.
+ */
+Buffer
+_bitmap_getbuf(Relation rel, BlockNumber blkno, int access)
+{
+	Buffer buf;
+
+/*
+	if (blkno == P_NEW)
+		ereport(ERROR,
+			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+			 errmsg("bitmap index does not use P_NEW")));
+*/
+
+	buf = ReadBuffer(rel, blkno);
+	if (access != BM_NOLOCK)
+		LockBuffer(buf, access);
+
+	return buf;
+}
+
+/*
+ * _bitmap_wrtbuf() -- write a buffer page to disk.
+ *
+ * Release the lock and the pin held on the buffer.
+ */
+void
+_bitmap_wrtbuf(Buffer buf)
+{
+	MarkBufferDirty(buf);
+	UnlockReleaseBuffer(buf);
+}
+
+/*
+ * _bitmap_wrtnorelbuf() -- write a buffer page to disk without still holding
+ *		the pin on this page.
+ */
+void
+_bitmap_wrtnorelbuf(Buffer buf)
+{
+	MarkBufferDirty(buf);
+}
+
+/*
+ * _bitmap_relbuf() -- release the buffer without writing.
+ */
+void
+_bitmap_relbuf(Buffer buf)
+{
+	UnlockReleaseBuffer(buf);
+}
+
+/*
+ * _bitmap_init_lovpage -- initialize a new LOV page.
+ */
+void
+_bitmap_init_lovpage(Relation rel, Buffer buf)
+{
+	Page			page;
+
+	page = (Page) BufferGetPage(buf);
+	Assert (PageIsNew(page));
+
+	PageInit(page, BufferGetPageSize(buf), 0);
+
+}
+
+/*
+ * _bitmap_init_bitmappage() -- initialize a new page to store the bitmap.
+ *
+ * Note: This function requires an exclusive lock on the metapage.
+ */
+void
+_bitmap_init_bitmappage(Relation rel, Buffer buf)
+{
+	Page			page;
+	BMBitmapOpaque	opaque;
+
+	page = (Page) BufferGetPage(buf);
+	Assert (PageIsNew(page));
+
+	PageInit(page, BufferGetPageSize(buf), sizeof(BMBitmapOpaqueData));
+
+	opaque = (BMBitmapOpaque) PageGetSpecialPointer(page);
+	opaque->bm_hrl_words_used = 0;
+	opaque->bm_bitmap_next = InvalidBlockNumber;
+	opaque->bm_last_tid_location = 0;
+}
+
+/*
+ * _bitmap_init_buildstate() -- initialize the build state before building
+ *	a bitmap index.
+ */
+void
+_bitmap_init_buildstate(Relation index, BMBuildState*  bmstate)
+{
+	uint32		attno;
+
+	/* initialize the build state */
+	bmstate->bm_metabuf = _bitmap_getbuf(index, BM_METAPAGE, BM_WRITE);
+	bmstate->bm_tupDesc = RelationGetDescr(index);
+
+	bmstate->bm_tidLocsBuffer = (BMTidLocsBuffer*)
+		palloc0(BM_MAX_TIDLOCS_BUFFER_SIZE);
+	bmstate->bm_tidLocsBuffer->bm_max_values = BM_NUM_DISTINCT_VALUES;
+
+	bmstate->bm_num_lov_blocks = 0;
+	bmstate->bm_max_num_lov_blocks = BM_NUM_LOV_BLOCKS;
+	bmstate->bm_lov_blocks = (BlockNumber*)
+		palloc0(bmstate->bm_max_num_lov_blocks*sizeof(BlockNumber));
+
+	_bitmap_open_lov_heapandindex
+		(index, (BMMetaPage)BufferGetPage(bmstate->bm_metabuf),
+		 &(bmstate->bm_lov_heap),
+		 &(bmstate->bm_lov_index), 
+		 RowExclusiveLock);
+
+	_bitmap_wrtnorelbuf(bmstate->bm_metabuf);
+	LockBuffer(bmstate->bm_metabuf, BUFFER_LOCK_UNLOCK);
+
+	bmstate->bm_lov_scanKeys =
+		(ScanKey)palloc0(bmstate->bm_tupDesc->natts * sizeof(ScanKeyData));
+	for (attno=0; attno<bmstate->bm_tupDesc->natts; attno++)
+	{
+		RegProcedure	opfuncid;
+
+		opfuncid = 
+			equality_oper_funcid
+				(bmstate->bm_tupDesc->attrs[attno]->atttypid);
+
+		ScanKeyEntryInitialize
+			(&(bmstate->bm_lov_scanKeys[attno]), SK_ISNULL, attno+1,
+			BTEqualStrategyNumber, InvalidOid, opfuncid, 0);
+	}
+
+	bmstate->bm_lov_scanDesc = 
+		index_beginscan (bmstate->bm_lov_heap,
+						 bmstate->bm_lov_index,
+						 true,
+						 SnapshotAny, bmstate->bm_tupDesc->natts,
+						 bmstate->bm_lov_scanKeys);
+}
+
+/*
+ * _bitmap_cleanup_buildstate() -- clean up the build state after
+ *	inserting all rows in the heap into the bitmap index.
+ */
+void
+_bitmap_cleanup_buildstate(Relation index, BMBuildState* bmstate)
+{
+	/* write out remaining tids in bmstate->bm_tidLicsBuffer */
+	BMTidLocsBuffer*	tidLocsBuffer = bmstate->bm_tidLocsBuffer;
+	_bitmap_write_alltids(index, bmstate->bm_metabuf, tidLocsBuffer,
+						  BM_MAX_TIDLOCS/tidLocsBuffer->bm_max_values - 1,
+						  bmstate->bm_lov_blocks);
+
+	index_endscan(bmstate->bm_lov_scanDesc);
+
+	ReleaseBuffer(bmstate->bm_metabuf);
+
+	_bitmap_close_lov_heapandindex
+		(bmstate->bm_lov_heap,bmstate->bm_lov_index,
+		 RowExclusiveLock);
+
+	pfree(bmstate->bm_tidLocsBuffer);
+	pfree(bmstate->bm_lov_blocks);
+	pfree(bmstate->bm_lov_scanKeys);
+}
+
+/*
+ * _bitmap_init() -- initialize the bitmap index.
+ *
+ * Create the meta page, a new heap which stores the distinct values for
+ * the attributes to be indexed, a btree index on this new heap for searching
+ * those distinct values, and the first LOV page.
+ */
+void
+_bitmap_init(Relation rel)
+{
+	BMMetaPage		metapage;
+	Buffer			metabuf;
+	Page			page;
+	Buffer			buf;
+	BMLOVItem 		lovItem;
+	OffsetNumber	newOffset;
+	Page			currLovPage;
+  
+	/* sanity check */
+	if (RelationGetNumberOfBlocks(rel) != 0)
+		ereport (ERROR,
+				(errcode(ERRCODE_INDEX_CORRUPTED),
+				errmsg("cannot initialize non-empty bitmap index \"%s\"",
+				RelationGetRelationName(rel))));
+
+	/* create the metapage */
+	metabuf = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+	page = BufferGetPage(metabuf);
+	Assert (PageIsNew(page)) ;
+
+	/* initialize the metapage */
+	PageInit(page, BufferGetPageSize(metabuf), 0);
+	metapage = (BMMetaPage) page;
+	metapage->bm_num_tuples = 0;
+	metapage->bm_need_rebuilt = false;
+	
+	/* initialize the LOV metadata */
+	_bitmap_create_lov_heapandindex(rel,
+									&(metapage->bm_lov_heapId),
+									&(metapage->bm_lov_indexId));
+
+	/* allocate the first LOV page. */
+	buf = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+	_bitmap_init_lovpage(rel, buf);
+
+	_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWLOV, buf, metapage);
+
+	currLovPage = BufferGetPage(buf);
+
+	/* set the first item to support NULL value */
+	lovItem = _bitmap_formitem(0);
+	newOffset = OffsetNumberNext(PageGetMaxOffsetNumber(currLovPage));
+
+	if (PageAddItem(currLovPage, (Item)lovItem, 
+					sizeof(BMLOVItemData), newOffset,
+					LP_USED) == InvalidOffsetNumber)
+		ereport(ERROR,
+				(errcode(ERRCODE_INTERNAL_ERROR),
+				errmsg("failed to add LOV item to \"%s\"",
+				RelationGetRelationName(rel))));
+
+	metapage->bm_lov_lastpage = BufferGetBlockNumber(buf);
+
+	_bitmap_log_lovitem(rel, buf, true, newOffset, lovItem);
+	pfree(lovItem);
+
+	_bitmap_wrtbuf(buf);
+
+	_bitmap_log_metapage(rel, metapage);
+
+	/* write the metapage */
+	_bitmap_wrtbuf(metabuf);
+}
diff -Naur src.pgsql/backend/access/bitmap/bitmapsearch.c src.bizgres/backend/access/bitmap/bitmapsearch.c
--- src.pgsql/backend/access/bitmap/bitmapsearch.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmapsearch.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,406 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmapsearch.c
+ *	  Search routines for on-disk bitmap index access method.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/tupdesc.h"
+#include "access/bitmap.h"
+#include "storage/lmgr.h"
+#include "parser/parse_oper.h"
+
+static void _bitmap_findbitmaps(IndexScanDesc scan, ScanDirection dir);
+static void _bitmap_comp_next_batch_words(IndexScanDesc scan);
+static void
+_bitmap_readWords(Relation rel, Buffer lovBuffer, OffsetNumber lovOffset,
+				  BlockNumber* nextBlockNoP,
+				  BM_HRL_WORD* headerWords, BM_HRL_WORD* words,
+				  uint32* numOfWordsP, bool* readLastWords);
+
+/*
+ * _bitmap_first() -- find the first tuple that satisfies a given scan.
+ */
+bool
+_bitmap_first(IndexScanDesc scan,
+			  ScanDirection dir)
+{
+	_bitmap_findbitmaps(scan, dir);
+	return _bitmap_next(scan, dir);
+}
+
+/*
+ * _bitmap_next() -- return the next tuple that satisfies a given scan.
+ */
+bool
+_bitmap_next(IndexScanDesc scan,
+			 ScanDirection dir)
+{
+	BMScanOpaque	so ;
+	BMScanPosition	scanPos;
+	uint64			nextTid;
+
+	so = (BMScanOpaque) scan->opaque;
+	scanPos = so->bm_currPos;
+
+	if (scanPos->bm_done)
+		return false;
+
+	for (;;) {
+		/*
+		 * If there are no more words left from the previous scan, we
+		 * try to compute the next batch of words.
+		 */
+		if (scanPos->bm_batchWords->numOfWords == 0 &&
+			scanPos->bm_result.nextTidLoc >=
+				scanPos->bm_result.numOfTids) {
+			_bitmap_reset_batchwords(scanPos->bm_batchWords);
+			scanPos->bm_batchWords->firstTid = scanPos->bm_result.nextTid;
+
+			_bitmap_comp_next_batch_words(scan);
+
+			_bitmap_begin_iterate(scanPos->bm_batchWords,
+								  &(scanPos->bm_result));
+		}
+
+		/* If we can not find more words, then this scan is over. */
+		if (scanPos->bm_batchWords->numOfWords == 0 &&
+			scanPos->bm_result.nextTidLoc >=
+				scanPos->bm_result.numOfTids)
+			return false;
+
+		nextTid = _bitmap_findnexttid(scanPos->bm_batchWords,
+									  &(scanPos->bm_result));
+		if (nextTid == 0)
+			continue;
+		else
+			break;
+	}
+
+	Assert((nextTid%MaxNumHeapTuples)+1 > 0);
+
+	ItemPointerSet(&(scan->xs_ctup.t_self),
+				   (nextTid-1)/MaxNumHeapTuples,
+				   ((nextTid-1)%MaxNumHeapTuples)+1);
+	scan->currentItemData = scan->xs_ctup.t_self;
+
+	return true;
+}
+
+/*
+ * _bitmap_firstblockwords() -- find the first block of bitmap words
+ *  in a bitmap vector for a given scan.
+ */
+bool
+_bitmap_firstblockwords(IndexScanDesc scan,
+						ScanDirection dir)
+{
+	_bitmap_findbitmaps(scan, dir);
+
+	return _bitmap_nextblockwords(scan, dir);
+}
+
+/*
+ * _bitmap_nextblockwords() -- find the next block of bitmap words
+ *  in a bitmap vector for a given scan.
+ */
+bool
+_bitmap_nextblockwords(IndexScanDesc scan,
+					   ScanDirection dir)
+{
+	BMScanOpaque	so;
+
+	so = (BMScanOpaque) scan->opaque;
+
+	/* check if this scan if over */
+	if (so->bm_currPos->bm_done)
+		return false;
+
+	_bitmap_comp_next_batch_words(scan);
+
+	return true;
+}
+
+/*
+ * _bitmap_comp_next_batch_words() -- compute the next batch of bitmap words
+ * 	from a given scan position.
+ */
+static void
+_bitmap_comp_next_batch_words(IndexScanDesc scan) {
+	BMScanPosition			scanPos;
+	BMBitmapScanPosition	bmScanPos;
+
+	scanPos = ((BMScanOpaque) scan->opaque)->bm_currPos;
+	bmScanPos = (BMBitmapScanPosition) 
+		(((char*)scanPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+	/*
+	 * If there are no words left from previous scan, read the next
+	 * batch of words.
+	 */
+	if (bmScanPos->bm_batchWords->numOfWords == 0 &&
+		!(bmScanPos->bm_readLastWords)) {
+		BMBatchWords*	batchWords;
+
+		batchWords = bmScanPos->bm_batchWords;
+		_bitmap_readWords(scan->indexRelation,
+						  bmScanPos->bm_lovBuffer,
+						  bmScanPos->bm_lovOffset,
+						  &(bmScanPos->bm_nextBlockNo),
+						  batchWords->bitmapHeaderWords,
+						  batchWords->bitmapContentWords,
+					  	  &(batchWords->numOfWords),
+						  &(bmScanPos->bm_readLastWords));
+	}
+
+	if (bmScanPos->bm_batchWords->numOfWords == 0)
+		scanPos->bm_done = true;
+}
+
+/*
+ * _bitmap_readWords() -- read one-block of bitmap words from
+ *	the bitmap page.
+ *
+ * If nextBlockNo is an invalid block number, then the two last words
+ * are stored in lovItem. Otherwise, read words from nextBlockNo.
+ */
+static void
+_bitmap_readWords(Relation rel, Buffer lovBuffer, OffsetNumber lovOffset,
+				  BlockNumber* nextBlockNoP,
+				  BM_HRL_WORD* headerWords, BM_HRL_WORD* words,
+				  uint32* numOfWordsP, bool* readLastWords)
+{
+	if (BlockNumberIsValid(*nextBlockNoP))
+	{
+		Buffer bitmapBuffer =
+			_bitmap_getbuf(rel, *nextBlockNoP, BM_READ);
+
+		Page			bitmapPage;
+		BMBitmap		bitmap;
+		BMBitmapOpaque	bitmapOpaque;
+
+		bitmapPage = BufferGetPage(bitmapBuffer);
+
+		bitmap = (BMBitmap) PageGetContents(bitmapPage);
+		bitmapOpaque = (BMBitmapOpaque)
+			PageGetSpecialPointer(bitmapPage);
+
+		*numOfWordsP = bitmapOpaque->bm_hrl_words_used;
+		memcpy(headerWords, bitmap->bm_headerWords,
+				BM_MAX_NUM_OF_HEADER_WORDS*sizeof(BM_HRL_WORD));
+		memcpy(words, bitmap->bm_contentWords, 
+				sizeof(BM_HRL_WORD)*(*numOfWordsP));
+
+		*nextBlockNoP = bitmapOpaque->bm_bitmap_next;
+
+		_bitmap_relbuf(bitmapBuffer);
+
+		*readLastWords = false;
+
+		/* if this is the last bitmap page and the total number of words
+		   in this page is less than or equal to
+		   BM_NUM_OF_HRL_WORDS_PER_PAGE - 2, we read the last two words
+		   and append them into 'headerWords' and 'words'. */
+		if ((!BlockNumberIsValid(*nextBlockNoP)) &&
+			(*numOfWordsP <= BM_NUM_OF_HRL_WORDS_PER_PAGE - 2))
+		{
+			BM_HRL_WORD	lastWords[2];
+			BM_HRL_WORD	lastHeaderWords;
+			uint32		numWords;
+
+			_bitmap_readWords(rel, lovBuffer, lovOffset, nextBlockNoP,
+							  &lastHeaderWords, lastWords, &numWords,
+							  readLastWords);
+
+			Assert(numWords == 2);
+
+			memcpy(words+(*numOfWordsP), lastWords, 2*sizeof(BM_HRL_WORD));
+			headerWords[(*numOfWordsP)/BM_HRL_WORD_SIZE] |=
+				(lastHeaderWords >> ((*numOfWordsP)%BM_HRL_WORD_SIZE));
+			if ((*numOfWordsP) % BM_HRL_WORD_SIZE == BM_HRL_WORD_SIZE-1)
+				headerWords[((*numOfWordsP)+1)/BM_HRL_WORD_SIZE] |=
+					(lastHeaderWords << 1);
+			*numOfWordsP += 2;
+		}
+	}
+
+	else {
+		BMLOVItem	lovItem;
+		Page		lovPage;
+
+		LockBuffer(lovBuffer, BM_READ);
+
+		lovPage = BufferGetPage(lovBuffer);
+		lovItem = (BMLOVItem) 
+			PageGetItem(lovPage, PageGetItemId (lovPage, lovOffset));
+
+		if (lovItem->bm_last_compword != LITERAL_ALL_ONE) {
+			*numOfWordsP = 2;
+			headerWords[0] = (((BM_HRL_WORD)lovItem->bm_last_two_headerbits) <<
+							  (BM_HRL_WORD_SIZE-2));
+			words[0] = lovItem->bm_last_compword;
+			words[1] = lovItem->bm_last_word;
+		}
+
+		else {
+			*numOfWordsP = 1;
+			headerWords[0] = (((BM_HRL_WORD)lovItem->bm_last_two_headerbits) <<
+							  (BM_HRL_WORD_SIZE-1));
+			words[0] = lovItem->bm_last_word;
+		}
+
+		LockBuffer(lovBuffer, BUFFER_LOCK_UNLOCK);
+
+		*readLastWords = true;
+	}
+}
+
+/*
+ * _bitmap_findbitmaps() -- find the bitmaps that satisfy the index predicate.
+ */
+void
+_bitmap_findbitmaps(IndexScanDesc scan,
+					ScanDirection dir)
+{
+	BMScanOpaque			so ;
+	BMScanPosition			scanPos;
+	BMBitmapScanPosition	bmScanPos;
+	Buffer					metabuf;
+	BMMetaPage				metapage;
+	BlockNumber				lovBlock;
+	OffsetNumber			lovOffset;
+	bool					blockNull, offsetNull;
+	bool					isnull = true;
+	int						keyNo;
+	Page 					lovPage;
+	BMLOVItem				lovItem;
+
+	so = (BMScanOpaque) scan->opaque;
+	Assert(so->bm_currPos == NULL);
+
+	/* initialize so->bm_currPos */
+	so->bm_currPos = (BMScanPosition) palloc0
+		(MAXALIGN(sizeof(BMScanPositionData)) +
+		 sizeof(BMBitmapScanPositionData));
+	scanPos = so->bm_currPos;
+
+	scanPos->bm_done = false;
+	scanPos->bm_numBitmapVectors = 1;
+	memset(&(scanPos->bm_result), 0, sizeof(BMIterateResult));
+
+	bmScanPos = (BMBitmapScanPosition) 
+		(((char*)scanPos) + MAXALIGN(sizeof(BMScanPositionData)));
+
+	metabuf = 
+		_bitmap_getbuf(scan->indexRelation, BM_METAPAGE, BM_READ);
+	metapage = (BMMetaPage)BufferGetPage(metabuf);
+
+	for (keyNo = 0; keyNo < scan->numberOfKeys; keyNo++) {
+		if (!((scan->keyData[keyNo]).sk_flags & SK_ISNULL))
+			isnull = false;
+	}
+
+	/*
+	 * If the values for these keys are all NULL, the bitmap vector
+	 * is the first LOV item in the LOV pages.
+	 */
+	if (isnull)
+	{
+		lovBlock = BM_LOV_STARTPAGE;
+		lovOffset = 1;
+	} else {
+		Relation		lovHeap, lovIndex;
+		TupleDesc		indexTupDesc;
+		ScanKey			scanKey;
+		IndexScanDesc	scanDesc;
+		Datum*			datum;
+		bool*			nulls;
+
+		/* Finds the bitmap vector by scanning through the auxiliary btree.*/
+		_bitmap_open_lov_heapandindex
+				(scan->indexRelation, metapage, 
+				 &lovHeap, &lovIndex, AccessShareLock);
+
+		indexTupDesc = RelationGetDescr(lovIndex);
+
+		Assert(scan->numberOfKeys <= indexTupDesc->natts);
+
+		scanKey = palloc0(scan->numberOfKeys * sizeof(ScanKeyData));
+		for (keyNo = 0; keyNo < scan->numberOfKeys; keyNo++) {
+			RegProcedure	opfuncid;
+			ScanKey	oneScanKey = (ScanKey)
+				(((char*)scanKey) + keyNo * sizeof(ScanKeyData));
+
+			opfuncid =
+				equality_oper_funcid(indexTupDesc->attrs[keyNo]->atttypid);
+			ScanKeyEntryInitialize
+				(oneScanKey, SK_ISNULL, keyNo+1, 
+				 BTEqualStrategyNumber, InvalidOid, opfuncid, 0);
+		}
+		scanDesc =
+			index_beginscan (lovHeap, lovIndex, true, SnapshotAny,
+							 scan->numberOfKeys, scanKey);
+
+		datum = (Datum*)palloc0(scan->numberOfKeys * sizeof(Datum));
+		nulls = (bool*)palloc0(scan->numberOfKeys * sizeof(bool));
+		for (keyNo = 0; keyNo < scan->numberOfKeys; keyNo++) {
+			datum[keyNo] = scan->keyData[keyNo].sk_argument;
+			if ((scan->keyData[keyNo]).sk_flags & SK_ISNULL) {
+				nulls[keyNo] = true;
+			} else {
+				nulls[keyNo] = false;
+			}
+		}
+
+		/* If no such bitmap vector exists, then the scan is over. */
+		if (!_bitmap_findvalue(lovHeap, lovIndex, datum, nulls,
+							  scanKey, scanDesc,
+							  &lovBlock, &blockNull, &lovOffset, &offsetNull))
+			scanPos->bm_done = true;
+		
+		index_endscan(scanDesc);
+		_bitmap_close_lov_heapandindex(lovHeap, lovIndex, AccessShareLock);
+		pfree(scanKey);
+		pfree(datum);
+		pfree(nulls);
+	}
+
+	_bitmap_relbuf(metabuf);
+
+	if (scanPos->bm_done)
+		return;
+
+	bmScanPos->bm_lovOffset = lovOffset;
+	bmScanPos->bm_lovBuffer =
+			_bitmap_getbuf(scan->indexRelation, lovBlock, BM_READ);
+
+	lovPage	= BufferGetPage(bmScanPos->bm_lovBuffer);
+	lovItem = (BMLOVItem) 
+		PageGetItem(lovPage, PageGetItemId (lovPage, bmScanPos->bm_lovOffset));
+			
+	bmScanPos->bm_nextBlockNo = lovItem->bm_lov_head;
+	bmScanPos->bm_readLastWords = false;
+	bmScanPos->bm_batchWords = (BMBatchWords*)
+		palloc0(sizeof(BMBatchWords));
+	_bitmap_init_batchwords(bmScanPos->bm_batchWords,
+							BM_NUM_OF_HRL_WORDS_PER_PAGE,
+							CurrentMemoryContext);
+
+	/*
+	 * Since there is only one related bitmap vector, we share
+	 * the result OnDiskBitmapWords with that of this bitmap vector.
+	 */
+	scanPos->bm_batchWords = bmScanPos->bm_batchWords;
+
+	LockBuffer(bmScanPos->bm_lovBuffer, BUFFER_LOCK_UNLOCK);
+}
